/*
 * 20170326_m328_5ch_pwm.c
 *
 * Created: 2017-03-26 22:01:38
 * Author : uwezi
 */ 

#include <avr/io.h>
#include <stdio.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include "nokia5110.h"
#include "irmp.h"

ISR (TIMER2_OVF_vect)
{
  static uint8_t cnt=0;
  cnt ++;
  if (cnt & 1)
  {
    (void) irmp_ISR(); 
  }
}

void init(void)
{

  NOKIA_init(54);
  NOKIA_clearbuffer();
  NOKIA_print_P(0,0,"IR Sniffer",0);
  NOKIA_update();

  // Timer 0
  // no prescaler, fast PWM mode 011
  TCCR0A = (0 << COM0A1) | (0 << COM0A0) | (0 << COM0B1) | (0 << COM0B0)
         | (1 << WGM01)  | (1 << WGM00);
  TCCR0B = (0 << WGM02) | (0 << CS02) | (0 << CS01) | (0 << CS00);
  // Timer 1
  // no prescaler, fast PWM mode 0101
  TCCR1A = (0 << COM1A1) | (0 << COM1A0) | (0 << COM1B1) | (0 << COM1B0)
         | (0 << WGM11)  | (1 << WGM10);
  TCCR1B = (0 << WGM13) | (0 << WGM12) | (0 << CS12) | (0 << CS11) | (0 << CS10);
  // Timer 2
  // no prescaler, fast PWM mode 011
  TCCR2A = (0 << COM2A1) | (0 << COM2A0) | (0 << COM2B1) | (0 << COM2B0)
         | (1 << WGM21)  | (1 << WGM20);
  TCCR2B = (0 << WGM22) | (0 << CS22) | (0 << CS21) | (1 << CS20);

  // interrupts on Timer 2
  TIMSK2 = (1 << TOIE2);
  sei();
}

int main(void)
{
  char buffer[40];
/*
  NOKIA_init(0);
  uint8_t i=0;
  while (1)
  {
    NOKIA_setVop(i);
    NOKIA_scroll(16);
    sprintf_P(buffer, PSTR("#%2d"),i);
    NOKIA_print(0,32,buffer,0);
    NOKIA_update();
    _delay_ms(100);
    i++;
  }
*/
  IRMP_DATA irmp_data;

  init();

    while (1) 
    {
      if (irmp_get_data (&irmp_data))
      {
        NOKIA_scroll(16);
        NOKIA_print_P(0,0,"IR Sniffer",0);
          
        sprintf_P(buffer, PSTR("#%2d"),irmp_data.protocol);
        NOKIA_print(0,32,buffer,0);

        sprintf_P(buffer, PSTR("A:%04X C:%04X"),irmp_data.address,irmp_data.command);
        NOKIA_print(0,40,buffer,0);
        NOKIA_update();
      }
    }
}

